;       --------------------   (  )------------------
(defun c:weld (/ osm autosn ortho dimscl cmd1 blm esl name data objtype)
  (initget 3)
  ;  
  (setvar "PLINEWID" 0)
  (setq osm (getvar "OSMODE"))
  (setq autosn (getvar "autosnap"))
  (setq ortho (getvar "ORTHOMODE"))
  (setq dimscl (getvar "dimscale"))
  (setq cmd1 (getvar "CMDECHO")
	blm (getvar "BLIPMODE"))
  ; 
  (setq esl (entsel " : "))
  (setq name (car esl))
  (setq data (entget name))
  (setq objtype (cdr (assoc 0 data)))
  (if (eq objtype "LINE")
    (weldline)
    (if (or (eq objtype "ARC") (eq objtype "CIRCLE"))
      (weldarc)
      )
    )
  ;  (  )
  (setvar "CMDECHO" cmd1)
  (setvar "BLIPMODE" blm)
  (setvar "OSMODE" osm)
  (setvar "PLINEWID" 0)
  (setvar "autosnap" autosn)
  )

;       ----------------------     --------------------------
(defun weldline (/ spt ept alfa alfa1 beta pta pttmp a h step k l n pt1 pt2 pt3 pt4 ptnexts ptnexte)
  (initget 4);  
  (setq	spt (getpoint "\n    : "))
  (setq ept (getpoint spt "\n    : "))
  (setq step (* dimscl 1.5))
  (setq h (* dimscl 1.0))
  ;  
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "OSMODE" 0)
  (setvar "ORTHOMODE" 0)
  (command "pline" spt ept ""); 
  (setq alfa (angle spt ept))
  (setq pttmp (polar spt alfa (* 0.5 (distance spt ept))))
  (setq	pta (getpoint pttmp "\n    : "))
  (command "erase" "last" "");  
  (setq beta (angle pttmp pta))
  (if (<= alfa pi)
    (setq alfa1 alfa)
    (setq alfa1 (- alfa pi))
    )
  (if (> beta alfa1)
    (if (< (- beta alfa1) pi)
      (setq beta (+ alfa1 (/ pi 2)))
      (setq beta (- alfa1 (/ pi 2)))
      )
    (setq beta (- alfa1 (/ pi 2)))
    )
  
  (setq l (distance spt ept))
  (setq n 0)
  (while (>= (- l (* step n)) 0)
    (setq n (+ n 1))
  ); while
  (setq n (- n 1))
  (if (= (- l (* step n)) 0)
    (setq k (/ step 2))
    (setq k (/ (- l (* step n)) 2))); if
  (setq a (getint "\n  ? ( 0  ) : "))
  (if (eq a 0)
    (progn
      (setq ptnexts (polar spt alfa k))
      (setq pt1 (polar ptnexts (+ alfa pi) (/ h 2)))
      (setq pt2 (polar ptnexts alfa (/ h 2)))
      (setq pt3 (polar pt1 beta h))
      (setq pt4 (polar pt2 beta h))
      (command "line" pt1 pt4 "")
      (command "line" pt2 pt3 "")
      (while (< (distance spt ptnexts) (- l step))
	(progn
	  (setq ptnexts (polar ptnexts alfa step))
	  (setq pt1 (polar ptnexts (+ alfa pi) (/ h 2)))
	  (setq pt2 (polar ptnexts alfa (/ h 2)))
	  (setq pt3 (polar pt1 beta h))
	  (setq pt4 (polar pt2 beta h))
	  (command "line" pt1 pt4 "")
	  (command "line" pt2 pt3 "")
	  ); progn
	); while
      ); progn
    (progn
      (setq ptnexts (polar spt alfa k))
      (setq ptnexte (polar ptnexts beta h))
      (command "line" ptnexts ptnexte "")
      (while (< (distance spt ptnexts) l)
	(progn
	  (setq ptnexts (polar ptnexts alfa step))
	  (setq ptnexte (polar ptnexts beta h))
	  (command "line" ptnexts ptnexte "")
	  ); progn
	); while
      (command "erase" "last" "")
      ); progn
    ); if
); 

;        ------------------       ---------------
(defun weldarc (/ cpt R step h a beta n spt pta Rtmp ept alfa1 alfa2 l alfa beta1 name1 name2 beta2 pt1 pt2 pt3 pt4)
  (setq cpt (cdr (assoc 10 data)))
  (setq R (cdr (assoc 40 data)))
  (setq step (* dimscl 1.5))
  (setq h (* dimscl 1.0))
  
  (if (eq objtype "CIRCLE")
    (progn
      (setq a (getint "\n    ? ( 0,  ) : "))
      (if (eq a 0)
	(progn
	  (setq beta (* pi 2))
	  (setq n (/ (* 2 (* pi R)) step))
	  (setq spt (polar cpt 0 R))
	  (setq pta (getpoint cpt "\n    : "))
	  (setq Rtmp (distance cpt pta))
	  (if (<= Rtmp R)
	    (progn
	      (setq ept (polar spt pi h))
	      (setq alfa2 pi)
	      )
	    (progn
	       (setq ept (polar spt 0 h))
	      (setq alfa2 0)
	   )
	    ); if
	  ); prog
	(progn
	  (setq spt (getpoint "\n    : "))
	  (setq ept (getpoint spt "\n    : "))
	  (setq alfa1 (angle cpt spt))
	  (setq alfa2 (angle cpt ept))
	  (if (> alfa1 alfa2)
	    (setq alfa1 (- alfa1 (* pi 2)))
	    ); if
	  (setq beta (- alfa2 alfa1))
	  (setq l (abs (* beta R)))
	  (setq n (/ l step))
	  (setq pta (getpoint cpt "\n    : "))
	  (setq spt (polar cpt alfa1 R))
	  (setq Rtmp (distance cpt pta))
	  (if (<= Rtmp R)
	    (setq alfa2 (+ alfa1 pi))
	    (setq alfa2 alfa1)
	    ); if
	  (setq ept (polar spt alfa2 h))
	  ); prog
	); if
      ); progn
    (progn
      (setq spt (getpoint "\n    : "))
      (setq ept (getpoint spt "\n    : "))
      (setq alfa1 (angle cpt spt))
      (setq alfa2 (angle cpt ept))
      (if (> alfa1 alfa2)
	 (setq alfa1 (- alfa1 (* pi 2)))
	 ); if
      (setq beta (- alfa2 alfa1))
      (setq l (abs (* beta R)))
      (setq n (/ l step))
      (setq pta (getpoint cpt "\n    : "))
      (setq spt (polar cpt alfa1 R))
      (setq Rtmp (distance cpt pta))
      (if (<= Rtmp R)
	(setq alfa2 (+ alfa1 pi))
	(setq alfa2 alfa1)
	); if
      (setq ept (polar spt alfa2 h))
      ); progn
    ); if
  ;  
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "OSMODE" 0)
  (setvar "ORTHOMODE" 0)
  (setq n (fix n))
  (setq a (getint "\n  ? ( 0  ) : "))
  (setq beta (/ (* beta 180) pi))
  (setq beta (fix beta))
  (if (eq a 0)
    (progn
      (setq h (/ h 2))
      (setq beta1 (+ alfa2 (/ pi 2)))
      (setq beta2 (- alfa2 (/ pi 2)))
      (setq pt1 (polar spt beta1 h))
      (setq pt2 (polar spt beta2 h))
      (setq pt3 (polar ept beta1 h))
      (setq pt4 (polar ept beta2 h))
      (command "line" pt1 pt4 "")
      (setq name1 (entlast))
      (command "line" pt2 pt3 "")
      (setq name2 (entlast))
      (command "array" name2 "" "P" cpt n beta "")
      ); progn
    (progn
      (command "line" spt ept "")
      (setq name1 (entlast))
      ); prog
    ); if
  (command "array" name1 "" "P" cpt n beta "")
  ); 